program DbgView;

uses
  Windows, Messages;

{$R main.res}
const
  IDD_DIALOG1 = 101;
  IDI_ICON1 = 102;
  IDC_LIST1 = 1000;
  IDC_EDIT1 = 1001;
  IDC_BUTTON1 = 1002;
  IDC_EDIT2 = 1003;
  IDC_BUTTON2 = 1004;
  IDC_BUTTON3 = 1005;
  szPipename = '\\.\pipe\AssasDebugView';
  bufsize = 4096;

var
  hPipe: THandle;
  hpipeThread: THandle;
  appIcon: HICON;
  csGUIAccess: TRTLCriticalSection;

function MyCreateThread(lpStartAddress: Pointer; lpParameter: Pointer; dwCreationFlags: DWORD; var lpThreadID: DWORD): THandle;
begin
  result := CreateThread(nil, 0, lpStartAddress, lpParameter, dwCreationFlags, lpThreadID);
end;

procedure DbgOut(hwnd: HWND; pc: PChar);
var
  i: LRESULT;
begin
  EnterCriticalSection(csGUIAccess);
  try
    SendMessage(hwnd, LB_ADDSTRING, 0, Longint(pc));
    i := SendMessage(hwnd, LB_GETCOUNT, 0, 0);
    if i <> LB_ERR then
    begin
      SendMessage(hwnd, LB_SETTOPINDEX, i - 1, 0);
    end;
  finally
    LeaveCriticalSection(csGUIAccess);
  end;
end;

function ThreadfuncWaitForClient(x: Pointer): DWORD; stdcall;
var
  fSuccess: Boolean;
  numread: DWORD;
  szbuf: array[0..bufsize - 1] of char;
  wnd: HWND;
begin
  result := 0;
  wnd := HWND(x);
  while ConnectNamedPipe(hPipe, nil) do
  try
    ZeroMemory(@szbuf, sizeof(szbuf));
    fSuccess := ReadFile(hPipe, szbuf, sizeof(szbuf), numread, nil);
    if fSuccess then
      if lstrlen(@szbuf) > 0 then
        DbgOut(wnd, @szbuf);
  finally
    DisconnectNamedPipe(hPipe);
  end;
end;

function DlgFunc(hwnd: hwnd; umsg: dword; wparam: wparam; lparam: lparam): bool; stdcall;
var
  l, i: Integer;
  pc: PChar;
begin
  result := true;
  case umsg of
    WM_INITDIALOG:
      begin
        SendMessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
        SendMessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        hpipeThread := MyCreateThread(@ThreadfuncWaitforClient, Pointer(GetDlgItem(hwnd, IDC_LIST1)), 0, PDWORD(nil)^);
      end;
    WM_CLOSE:
      begin
        TerminateThread(hpipeThread, 0);
        EndDialog(hWnd, 0);
      end;
    WM_COMMAND:
      case hiword(wparam) of
        LBN_SELCHANGE:
          if GetDlgCtrlID(lParam) = IDC_LIST1 then
          begin
            i := SendMessage(lParam, LB_GETCURSEL, 0, 0);
            case i of
              LB_ERR:
                SetDlgItemText(hwnd, IDC_EDIT2, nil);
            else
              begin
                l := SendMessage(lParam, LB_GETTEXTLEN, i, 0);
                pc := GetMemory(l + 1);
                if Assigned(pc) then
                try
                  ZeroMemory(pc, l + 1);
                  if SendMessage(lParam, LB_GETTEXT, i, Integer(pc)) <> LB_ERR then
                    SetDlgItemText(hwnd, IDC_EDIT2, pc);
                finally
                  FreeMemory(pc);
                end;
              end;
            end;
          end;
        BN_CLICKED:
          begin
            case loword(wparam) of
              IDOK:
                sendmessage(hwnd, WM_CLOSE, 0, 0);
              IDC_BUTTON2:
                begin
                  SendDlgItemMessage(hwnd, IDC_LIST1, LB_RESETCONTENT, 0, 0);
                end;
            end;
          end;
      end;
  else result := false;
  end;
end;

begin
  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
  InitializeCriticalSection(csGUIAccess);
  hPipe := CreateNamedPipe(szPipeName, PIPE_ACCESS_INBOUND, PIPE_TYPE_MESSAGE or PIPE_WAIT, PIPE_UNLIMITED_INSTANCES, bufsize, bufsize, 5000, nil);
  if hPipe <> INVALID_HANDLE_VALUE then
  begin
    DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @DlgFunc)
  end
  else
    Messagebox(0, 'The pipe already exist. Close the other instance of this viewer program!', nil, 0);
  CloseHandle(hPipe);
  DeleteCriticalSection(csGUIAccess);
end.

